<?php 

class AuthHelper{
    
protected $_sessionHelper,
          $_redirectorHelper,
          $_tableName,
          $_userColumn,
          $_passColumn,
          $_user,
          $_pass,
          $_loginController     = 'index',
          $_loginAction         = null,
          $_logoutController    = 'index',
          $_logoutAction        = null;
        

    public function __construct() {
        $this->_sessionHelper       = new SessionHelper();
        $this->_redirectorHelper    = new RedirectorHelper();
        return $this;
    }
    
    
    public function setTableName( $value ){
        $this->_tableName = $value;
        return $this;
    }
    
    
    public function setUserColumn( $value ){
        $this->_userColumn = $value;
        return $this;
    }
    
    
    public function setPassColumn( $value ){
        $this->_passColumn = $value;
        return $this;
    }
    
    
    public function setUser( $value ){
        $this->_user = $value;
        return $this;
    }
    
    
    public function setPass( $value ){
        $this->_pass = $value;
        return $this;
    }
    
    
    public function setLoginControllerAction( $controller, $action ){
        $this->_loginController = $controller;
        $this->_loginAction     = $action;
        return $this;
    }
    
    
    public function setLogoutControllerAction( $controller, $action ){
        $this->_logoutController = $controller;
        $this->_logoutAction     = $action;
        return $this;
    }
    
    
    public function login(){
        
        $db = new Model();
        $db->_tabela = $this->_tableName;
        $where = $this->_userColumn ." = '". $this->_user ."' AND ". $this->_passColumn ." = '". $this->_pass ."'";
        $sql = $db->doSelect(null,$where,"1");
		
        if( count($sql) > 0 ):
        $this->_sessionHelper->createSession("userAuth", true) 
                             ->createSession("userData", $this->_user);
        else:
            die("Usurio no existe!");
        endif;
        
        $this->_redirectorHelper->goToControllerAction($this->_loginController, $this->_loginAction);
        return $this;
    }
    
    public function logout(){
        
        $this->_sessionHelper->deleteSession("userAuth")
                             ->deleteSession("userData");
        
        $this->_redirectorHelper->goToControllerAction($this->_logoutController, $this->_logoutAction);
        return $this;
    }

    
    public function checkLogin( $action ){
        
        switch( $action ){
        
            case "boolean":
                if( !$this->_sessionHelper->checkSession("userAuth") )
                    return false;
                else
                    return true;
                break;
            case "redirect": 
                
                if( !$this->_sessionHelper->checkSession("userAuth") ):
                    if( $this->_redirectorHelper->getCurrentController() == null || $this->_redirectorHelper->getCurrentController() != $this->_loginController || $this->_redirectorHelper->getCurrentAction() == null || $this->_redirectorHelper->getCurrentAction() != $this->_loginAction ):
                        $this->_redirectorHelper->goToControllerAction ($this->_loginController, $this->_loginAction);
                    endif;
                else:
                    if( $this->_loginController == $this->_redirectorHelper->getCurrentController() || $this->_loginAction == $this->_redirectorHelper->getCurrentAction() ):
                        $this->_redirectorHelper->goToControllerAction('index',null);
                    endif;
                endif;
                
                break;
            case "stop":
                
                if( !$this->_sessionHelper->checkSession("userAuth") )
                    exit;
                break;
                
            }
            
        }
        
        public function userData( $key ){
            $s = $this->_sessionHelper->selectSession("userData");
            return $s[$key];    
        }    
    
}