<?php 
/** 
 * Classe de Ações do Modelo utilizando PDO
 * @author i9 design & tecnologia
 * @version 1.0
 *
 * classe Model
 * Gerencia as ações do banco de dados
 */

class Model{

    protected $db;
    private $_host      = '108.167.188.85';
    private $_dbname    = 'celab509_site';
    private $_user      = 'celab509_jk';
    private $_pass      = 'C1E2L3A4B5';
    public  $_tabela;

    public function __construct(){

        $this->db = new PDO("mysql:host={$this->_host};dbname={$this->_dbname}",$this->_user,  $this->_pass);

    }

    public function doSelect( $campos = null, $where = null, $order = null, $limit = null, $offset = null ){

        // Verifica se foi passado valor em $where, senão define como vazio.
		$campos	= ($campos	!= null ? "{$campos}" : "*");
        $where	= ($where	!= null ? "WHERE {$where}" : "");
        $order	= ($order	!= null ? "ORDER BY {$order}" : "");
        $limit	= ($limit	!= null ? "LIMIT {$limit}" : "");
        $offset = ($offset	!= null ? "OFFSET {$offset}" : "");

        // Define o comando SELECT utilizando a variável $where passada. 		
        $cmd = $this->db->query("SELECT {$campos} FROM `{$this->_tabela}` {$where} {$order} {$limit} {$offset}");
        $cmd->setFetchMode(PDO::FETCH_ASSOC);

		//return $cmd;

        // Executa o SELECT
        return $cmd->fetchAll(); 

    }

	public function doSelectCount($campo = null, $where = null){

        // Verifica se foi passado valor em $campo e $where, senão define como um valor padrão.
        $campo = ($campo != null ? "{$campo}" : "*");
		$where = ($where != null ? "WHERE {$where}" : "");

        // Define o comando SELECT utilizando a variável $where passada. 
        $cmd = $this->db->query("SELECT COUNT({$campo}) FROM `{$this->_tabela}` {$where}");
        $cmd->setFetchMode(PDO::FETCH_ASSOC);

        // Executa o SELECT
        return $cmd->fetchAll(); 

    }

	public function doSelectMax($campo){

        // Define o comando SELECT utilizando a variável $where passada. 
        $cmd = $this->db->query("SELECT MAX({$campo}) FROM `{$this->_tabela}`");
        $cmd->setFetchMode(PDO::FETCH_ASSOC);

        // Executa o SELECT
        $col = $cmd->fetchAll(); 

		foreach($col as $ind => $val):
			$coluna = implode(',',$val);
		endforeach;

		return $coluna;

    }

    public function doCommit( $sql ){

        // Define o comando utilizando a variável $sql passada. 
        $cmd = $this->db->query("{$sql}");
        $cmd->setFetchMode(PDO::FETCH_ASSOC);

        // Executa o SELECT
        return $cmd->fetchAll();
    }

    public function doSelectColumns($modo = 'any'){

        /*
         * $modo - recebe os valores any e all.
         * any   - exibe todas as colunas, escondendo apenas a coluna ID.
         * all   - exibe todas as colunas, inclusive a coluna ID.
         */

        // Define o comando SHOW para exibir as colunas da tabela.
        $cmd = $this->db->query("SHOW COLUMNS FROM `{$this->_tabela}`");
        $cmd->setFetchMode(PDO::FETCH_ASSOC);

        // Variável que vai conter todas as informações das colunas.
        $cmd_colunas = $cmd->fetchAll();

        // Percorre a variável que contém as informações e transforma em array.
        foreach($cmd_colunas as $col => $array): 

            // Percorre a array para pegar os indices e valores separados.
            foreach($array as $chave => $valor):

                // Verifica se o indice é o indice FIELD
                if ($chave === 'Field'){

                   // Cria uma array com os nomes dos campos
                   $this->coluna_nome[] = $valor;

                   // Verifica se é para exibir todas as colunas, excluindo a coluna ID.
                   if ($modo == 'any'):

                     // Exclui a coluna ID da array.
                     unset( $this->coluna_nome[0]); 

                   endif;

                   // Destrói a array e unifica as colunas separando por virgulas.
                   $colunas= implode(',', $this->coluna_nome);

               }

            endforeach;

        endforeach;

        // Retorna as colunas
        return $colunas;

    }

    public function doSelectNextId(){

        // Define o comando SHOW para exibir informações da tabela.
        $cmd = $this->db->query(" SHOW TABLE STATUS LIKE '{$this->_tabela}' ");
        $cmd->setFetchMode(PDO::FETCH_ASSOC);

        // Variável que vai conter os resultados.
        $cmd_exec = $cmd->fetchAll();
        $_cmd_exec = $cmd_exec[0];

        // Percorre a array para buscar os indices e valores
        foreach($_cmd_exec as $ind => $val):

            // Verifica se é o indice 'Auto_increment' para pegar seu valor
            if($ind === 'Auto_increment'):

                // Define a variável com o valor de Auto_increment.
                $_id = $val;

            endif;

        endforeach;

        // Retorna o ID.
        return $_id;

    }

    public function doInsert( $campos, $valores ){

        // Define o comando INSERT utilizando as variáveis $campos e $valores passados.
        $cmd = $this->db->query( "INSERT INTO {$this->_tabela} ({$campos}) VALUES ({$valores})" );

        // Executa o INSERT
        return $cmd;
            
    }

    public function doUpdate( $campos, $valores, $where ){

        // Pega os valores passados e os divide.
        $campos  = explode(',',$campos);
        $valores = explode(',',$valores);

        // Percorre os valores e transforma em array.
        foreach($campos as $campo){  $_campo[] = $campo;};
        foreach($valores as $valor){ $_valor[] = $valor;};

        // Combina as 2 arrays, formando apenas 1.
        $dados = array_combine($_campo,$_valor);

        // Percorre a nova array e formata para gravar no banco.
        foreach($dados as $ind => $val){ $_dados[] = "{$ind}={$val}"; };

        $_dados = implode(',',$_dados);

        // Define o comando UPDATE utilizando as variaveis formatadas.
        $cmd = $this->db->query("UPDATE {$this->_tabela} SET {$_dados} WHERE {$where}");

        // Executa o UPDATE
        return $cmd;

    }

    public function doDelete( $where ){

        // Define o comando DELETE utilizando a variavel $where.
        $cmd = $this->db->query("DELETE FROM `{$this->_tabela}` WHERE {$where}");

        // Executa o DELETE
        return $cmd;

    }

	public function doConfig( $page, $name){

        // Verifica se foi passado valor em $where, senão define como vazio.
        $where	= "WHERE page = '{$page}' AND name = '{$name}'";

        // Define o comando SELECT utilizando a variável $where passada. 
        $cmd = $this->db->query("SELECT valor FROM `config` {$where}");
        $cmd->setFetchMode(PDO::FETCH_ASSOC);

        // Executa o SELECT
        $consulta = $cmd->fetchAll(); 
		$retorno = $consulta[0];

		return $retorno['valor'];

    }

	public function doSocial(){                  

        // Define o comando SELECT utilizando a variável $where passada. 
        $cmd = $this->db->query("SELECT * FROM `social` WHERE situacao = 1 ORDER BY posicao ASC");
        $cmd->setFetchMode(PDO::FETCH_ASSOC);

        // Executa o SELECT
        $consulta = $cmd->fetchAll(); 			

		return $consulta;

    }

	public function _getItensMenuTopo(){

		 // Define o comando SELECT utilizando a variável $where passada. 
        $cmd = $this->db->query("SELECT * FROM `pages` WHERE menu = 1 ORDER BY posicao ASC");
        $cmd->setFetchMode(PDO::FETCH_ASSOC);

        // Executa o SELECT
        $consulta = $cmd->fetchAll(); 			

		return $consulta;

	}
	
}



?>