<?php
/**
 * Classe de Configuração System
 * @author i9 design & tecnologia
 * @version 1.0
 *
 * classe System
 * Gerencia as configurações
 */

class System {



    private $_url;
    private $_explode;
    public $_controller;
    public $_action;
    public $_params;
    public $_qrystr;
    public $_path;
    public $_baseUrl;
    public $_title;
    public $_metatitle;
    public $_metadescription;
    public $_metakeywords;

    public function __construct() {

        $this->setUrl();
        $this->setExplode();
        $this->setController();
        $this->setAction();
        //$this->setParams();
        $this->getPath();
        $this->getBaseUrl();

    } 

    public function getBaseUrl() {

        $protocol = (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
        $host = $_SERVER['HTTP_HOST'];
        $self = $_SERVER['PHP_SELF'];
        $hs = explode('/', "$host$self");
        $h = $hs[0];
        $s = $hs[1];

        $this->_baseUrl = str_replace("index.php/","",$protocol . $h . '/' . $s .'/');

        return $this->_baseUrl;

    }

    private function setUrl() {

        // Define o GET "url" com o valor passado ou "index/index_action" caso seja vazio.
        $_GET['url'] = (isset($_GET['url']) ? $_GET['url'] : 'index/index_action');

        // Define a variável de acesso private "_url" com o valor de GET.
        $this->_url = $_GET['url'];

    }

    private function setExplode() {

        $this->_explode = explode('/', $this->_url);

    }

    private function setController() {

        $controle = str_replace(".html", "", str_replace("-", " ", $this->_explode[0]));
        $controle = ucwords($controle);
        $this->_controller = str_replace(" ", "", $controle);

    }

    private function setAction() {

        $act = (!isset($this->_explode[1]) || $this->_explode[1] == null || $this->_explode[1] == 'index' ? 'index_action' : $this->_explode[1]);

        $this->_action = str_replace(".html", "", str_replace("-", "", $act));

    }

    private function setParams() {

        unset($this->_explode[0], $this->_explode[1]);

        if (end($this->_explode) == null) array_pop($this->_explode);

        $i = 0;

        if (!empty($this->_explode)):

            foreach ($this->_explode as $exp):

                if ($i % 2 == 0):
                    $indice[] = $exp;
                else:
                    $valor[] = $exp;
                endif;

                $i++;

            endforeach;

        else:

            $indice = array();
            $valor = array();

        endif;

        if (count($indice) == count($valor) && !empty($indice) && !empty($valor)):
            $this->_params = array_combine($indice, $valor);
        else:
            $this->_params = array();
        endif;

    }

    public function getParam($param = null) {

        if ($param != null):
            return $this->_params[$param];
        else:
            return $this->_params;
        endif;

    }

    public function getQryStr($param = null) {
        
        if(strrpos($_SERVER["REQUEST_URI"], "?")):

            $url = substr($_SERVER["REQUEST_URI"], strrpos($_SERVER["REQUEST_URI"], "?")+1);
           
            $replace = str_replace("=","/",$url);
            $replace = str_replace("&","/",$replace);
            $explode = explode("/", $replace);
            
            if (end($explode) == null)
                array_pop($explode);

            $i = 0;
            $indice = array();
            $valor = array();

            if (!empty($explode)):

                foreach ($explode as $exp):

                    if ($i % 2 == 0):
                        $indice[] = $exp;
                    else:
                        $valor[] = $exp;
                    endif;

                    $i++;

                endforeach;

            else:

                $indice = array();
                $valor = array();

            endif;
            
            if (count($indice) == count($valor) && !empty($indice) && !empty($valor)):
                $this->_qrystr = array_combine($indice, $valor);
            else:
                $this->_qrystr = '';
            endif;
                    
            if ($param != null):

                if(isset($this->_qrystr[$param])):
                    return urldecode($this->_qrystr[$param]);
                else:
                    return;
                endif;

            else:
                return $this->_qrystr;
            endif;

        else:
            return;
        endif;     

    }

    public function getPath() {

        if ($this->_controller != null || $this->_controller != "index"):
            return $this->_path = strtolower($this->_controller) . '/';
        else:
            return $this->_path = "index" . '/';
        endif;

    }

    public function getMedia($imagem, $caminho){

        return $this->_baseUrl . MEDIA . $caminho .'/' . $imagem;

    }



    public function getPageHtml($pagina) {

        $arquivo = VIEWS . 'includes/' . $pagina . '.phtml';

        require_once($arquivo);

    }

    public function getLayoutHtml($pagina, $pasta = null) {

        $pasta = ($pasta != null ? $pasta .'/' : '');

        $arquivo = APP .'layouts/'. $pasta . $pagina . '.phtml';

        //$conteudo = file_get_contents($arquivo);

        include($arquivo);

    }

    public function getFiles($diretorio) {

        // abre o diretório
        $ponteiro = opendir($diretorio);

        // monta os vetores com os itens encontrados na pasta
        while ($nome_itens = readdir($ponteiro)) {

            $itens[] = $nome_itens;

        }

        // ordena o vetor de itens
        sort($itens);

        // percorre o vetor para fazer a separacao entre arquivos e pastas 
        foreach ($itens as $listar) {

            // retira "./" e "../" para que retorne apenas pastas e arquivos
            if ($listar != "." && $listar != "..") {

                // checa se o tipo de arquivo encontrado é uma pasta
                if (is_dir($listar)) {

                    // caso VERDADEIRO adiciona o item à variável de pastas
                    $pastas[] = $listar;

                } else {

                    // caso FALSO adiciona o item à variável de arquivos
                    $arquivos[] = $listar;

                }

            }

        }

        return $arquivos;

    }

    public function getFolderFiles($diretorio) {

        // abre o diretério
        $ponteiro = opendir($diretorio);
        $arquivos = array();

        // monta os vetores com os itens encontrados na pasta
        while ($nome_itens = readdir($ponteiro)) {
            $itens[] = $nome_itens;
        }

        // ordena o vetor de itens
        sort($itens);

        // percorre o vetor para fazer a separacao entre arquivos e pastas 
        foreach ($itens as $listar) {
            // retira "./" e "../" para que retorne apenas pastas e arquivos
            if ($listar != "." && $listar != "..") {

                // checa se o tipo de arquivo encontrado é uma pasta
                if (is_dir($listar)) {
                    // caso VERDADEIRO adiciona o item à variável de pastas
                    $pastas[] = $listar;
                } else {
                    // caso FALSO adiciona o item à variável de arquivos
                    $arquivos[] = $listar;
                }
            }
        }

        foreach ($arquivos as $ind => $value):

            if (file_exists($diretorio . $value)):
                require_once($diretorio . $value);
            else:
                die('O arquivo Model ou Helper, não foram encontrados.');
            endif;

        endforeach;
    }

    public function getModels() {

        return $this->getFolderFiles(MODELS);
    }

    public function getHelpers() {

        return $this->getFolderFiles(HELPERS);
    }

    public function getExtension($arquivo) {

        // divide o arquivo baseado no caractere informado e cria um array
        $divideArquivo = explode(".", $arquivo);

        // conta quantos elementos foram criados no array divideArquivo
        $qtdElementos = count($divideArquivo) - 1;

        // pega a extensao do arquivo
        $extensao = $divideArquivo[$qtdElementos];

        return $extensao;

    }

    public function setLink($link){

        return $this->_baseUrl . $link;

    }

	public function setTitle($titulo){

		$this->_title = $titulo;	

	}

	public function setMeta($tipo, $conteudo){

		if($tipo == 'title'):

			$this->_metatitle = $conteudo;

		elseif($tipo == 'description'):

			$this->_metadescription = $conteudo;

		elseif($tipo == 'keywords'):

			$this->_metakeywords = $conteudo;

		else:

			$this->_metatitle = '';
			$this->_metadescription = '';
			$this->_metakeywords = '';

		endif;

	}


	public function getLib($lib, $page){

		$path = LIB . $lib .'/'. $page;

		if (file_exists($path)):
                require_once($path);
        else:
                die('A biblioteca: '.$lib.' não foi encontrada.');
        endif;

	}

	

    public function run() {

        $controller_path = CONTROLLERS . $this->_controller . 'Controller.php';
        //echo $controller_path;

        if (!file_exists($controller_path)) die(Header("Location: ". $this->setLink('erros.html')));

        require_once( $controller_path );

        $app = new $this->_controller();
		
        if (!method_exists($app, $this->_action)) die(header("Location: ". $this->setLink('erros.html')));

        $action = $this->_action;
        $app->$action();

    }

	public function config($page, $name){

			$config = new Model();
			$valor = $config->doConfig($page, $name);
			return $valor;			

	}

	public function getContato($info){

		return $this->config('contato',$info);

	}

	public function getGoogle($info){

		return $this->config('google',$info);

	}

	public function getTextos($info){

		return $this->config('inicial',$info);

	}

	public function mostraData ($data) {

	if ($data!='') {

	   return (substr($data,8,2).'/'.substr($data,5,2).'/'.substr($data,0,4));

	}

	else { return ''; }

	}

	public function retiraTagHTML($textoComTag){

    	echo strip_tags($textoComTag, '<(.*?)>');

    } 


	public function diaSemana($dia){

	switch($dia){

		case 1:
			$diaSemana = "Segunda-feira";
		break;

		case 2:
			$diaSemana = "Terça-feira";
		break;
		
		case 3:
			$diaSemana = "Quarta-feira";
		break;

		case 4:
			$diaSemana = "Quinta-feira";
		break;

		case 5:
			$diaSemana = "Sexta-feira";
		break;

		case 6:
			$diaSemana = "Sábado";
		break;

		case 7:
			$diaSemana = "Domingo";
		break;

	}

	return $diaSemana;

}

	public function social(){
			$social = new Model();
			return $social->doSocial();	
	}

	public function menuTopo(){

			$menu = new Model();
			return $menu->_getItensMenuTopo();

	}

    public function trataUrl($url) {

        $a = array('À','Á','Â','Ã','Ä','Å','Æ','Ç','È','É','Ê','Ë','Ì','Í','Î','Ï','Ð','Ñ','Ò','Ó','Ô','Õ','Ö','Ø','Ù','Ú','Û','Ü','Ý','ß','à','á','â','ã','ä','å','æ','ç','è','é','ê','ë','ì','í','î','ï','ñ','ò','ó','ô','õ','ö','ø','ù','ú','û','ü','ý','ÿ','Ā','ā','Ă','ă','Ą','ą','Ć','ć','Ĉ','ĉ','Ċ','ċ','Č','č','Ď','ď','Đ','đ','Ē','ē','Ĕ','ĕ','Ė','ė','Ę','ę','Ě','ě','Ĝ','ĝ','Ğ','ğ','Ġ','ġ','Ģ','ģ','Ĥ','ĥ','Ħ','ħ','Ĩ','ĩ','Ī','ī','Ĭ','ĭ','Į','į','İ','ı','Ĳ','ĳ','Ĵ','ĵ','Ķ','ķ','Ĺ','ĺ','Ļ','ļ','Ľ','ľ','Ŀ','ŀ','Ł','ł','Ń','ń','Ņ','ņ','Ň','ň','ŉ','Ō','ō','Ŏ','ŏ','Ő','ő','Œ','œ','Ŕ','ŕ','Ŗ','ŗ','Ř','ř','Ś','ś','Ŝ','ŝ','Ş','ş','Š','š','Ţ','ţ','Ť','ť','Ŧ','ŧ','Ũ','ũ','Ū','ū','Ŭ','ŭ','Ů','ů','Ű','ű','Ų','ų','Ŵ','ŵ','Ŷ','ŷ','Ÿ','Ź','ź','Ż','ż','Ž','ž','ſ','ƒ','Ơ','ơ','Ư','ư','Ǎ','ǎ','Ǐ','ǐ','Ǒ','ǒ','Ǔ','ǔ','Ǖ','ǖ','Ǘ','ǘ','Ǚ','ǚ','Ǜ','ǜ','Ǻ','ǻ','Ǽ','ǽ','Ǿ','ǿ');
        $b = array('A','A','A','A','A','A','AE','C','E','E','E','E','I','I','I','I','D','N','O','O','O','O','O','O','U','U','U','U','Y','s','a','a','a','a','a','a','ae','c','e','e','e','e','i','i','i','i','n','o','o','o','o','o','o','u','u','u','u','y','y','A','a','A','a','A','a','C','c','C','c','C','c','C','c','D','d','D','d','E','e','E','e','E','e','E','e','E','e','G','g','G','g','G','g','G','g','H','h','H','h','I','i','I','i','I','i','I','i','I','i','IJ','ij','J','j','K','k','L','l','L','l','L','l','L','l','l','l','N','n','N','n','N','n','n','O','o','O','o','O','o','OE','oe','R','r','R','r','R','r','S','s','S','s','S','s','S','s','T','t','T','t','T','t','U','u','U','u','U','u','U','u','U','u','U','u','W','w','Y','y','Y','Z','z','Z','z','Z','z','s','f','O','o','U','u','A','a','I','i','O','o','U','u','U','u','U','u','U','u','U','u','A','a','AE','ae','O','o');
        $map = str_replace($a, $b, $url);

        return strtolower(preg_replace(array('/[^a-zA-Z0-9 -]/', '/[ -]+/', '/^-|-$/'), array('', '-', ''), $map));
    }

}