<?php
class System

{
 private $_url;
 private $_explode;
 public $_controller;
 public $_action;
 public $_params;
 public $_path;
 public $_baseUrl;
 public $_title;
 public $_metatitle;
 public $_metadescription;
 public $_metakeywords;
 
 public
 
 function __construct()
 {
  $this->setUrl();
  $this->setExplode();
  $this->setController();
  $this->setAction();
  $this->setParams();
  $this->getPath();
  $this->getBaseUrl();
 }

 public

 function getBaseUrl()
 {
  $protocol = (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
  $host = $_SERVER['HTTP_HOST'];
  $self = $_SERVER['PHP_SELF'];
  $hs = explode('/', "$host$self");
  $h = $hs[0];
  $s = $hs[1];
  $this->_baseUrl = $protocol . $h . '/' . $s . '/';
  return $this->_baseUrl;
 }

 private
 function setUrl()
 {

  // Define o GET "url" com o valor passado ou "index/index_action" caso seja vazio.

  $_GET['url'] = (isset($_GET['url']) ? $_GET['url'] : 'index/index_action');

  // Define a vari?vel de acesso private "_url" com o valor de GET.

  $this->_url = $_GET['url'];
 }

 private
 function setExplode()
 {
  $this->_explode = explode('/', $this->_url);
 }

 private
 function setController()
 {
  $this->_controller = $this->_explode[0];
 }

 private
 function setAction()
 {
  $act = (!isset($this->_explode[1]) || $this->_explode[1] == null || $this->_explode[1] == 'index' ? 'index_action' : $this->_explode[1]);
  $this->_action = $act;
 }

 private
 function setParams()
 {
  unset($this->_explode[0], $this->_explode[1]);
  if (end($this->_explode) == null) array_pop($this->_explode);
  $i = 0;
  if (!empty($this->_explode)):
   foreach($this->_explode as $exp):
    if ($i % 2 == 0):
     $indice[] = $exp;
    else:
     $valor[] = $exp;
    endif;
    $i++;
   endforeach;
  else:
   $indice = array();
   $valor = array();
  endif;
  if (count($indice) == count($valor) && !empty($indice) && !empty($valor)):
   $this->_params = array_combine($indice, $valor);
  else:
   $this->_params = array();
  endif;
 }

 public

 function getParam($param = null)
 {
  if ($param != null):
   return $this->_params[$param];
  else:
   return $this->_params;
  endif;
 }

 public

 function getPath()
 {
  if ($this->_controller != null || $this->_controller != "index"):
   return $this->_path = $this->_controller . '/';
  else:
   return $this->_path = "index" . '/';
  endif;
 }

 public

 function getMedia($imagem, $caminho)
 {
  return $this->_baseUrl . MEDIA . $caminho . '/' . $imagem;
 }

 public

 function getPageHtml($pagina)
 {
  $arquivo = VIEWS . 'includes/' . $pagina . '.phtml';
  require_once ($arquivo);

 }

 public

 function getAdminPageHtml($pagina)
 {
  $arquivo = ADMIN . 'includes/' . $pagina . '.phtml';
  require_once ($arquivo);

 }

 public

 function getLayoutHtml($pagina, $pasta = null)
 {
  $pasta = ($pasta != null ? $pasta . '/' : '');
  $arquivo = APP . 'layouts/' . $pasta . $pagina . '.phtml';

  // $conteudo = file_get_contents($arquivo);

  include ($arquivo);

 }

 public

 function getFiles($diretorio)
 {

  // abre o diret?rio

  $ponteiro = opendir($diretorio);

  // monta os vetores com os itens encontrados na pasta

  while ($nome_itens = readdir($ponteiro)) {
   $itens[] = $nome_itens;
  }

  // ordena o vetor de itens

  sort($itens);

  // percorre o vetor para fazer a separacao entre arquivos e pastas

  foreach($itens as $listar) {

   // retira "./" e "../" para que retorne apenas pastas e arquivos

   if ($listar != "." && $listar != "..") {

    // checa se o tipo de arquivo encontrado ? uma pasta

    if (is_dir($listar)) {

     // caso VERDADEIRO adiciona o item ? vari?vel de pastas

     $pastas[] = $listar;
    }
    else {

     // caso FALSO adiciona o item ? vari?vel de arquivos

     $arquivos[] = $listar;
    }
   }
  }

  return $arquivos;
 }

 public

 function getExtension($arquivo)
 {

  // divide o arquivo baseado no caractere informado e cria um array

  $divideArquivo = explode(".", $arquivo);

  // conta quantos elementos foram criados no array divideArquivo

  $qtdElementos = count($divideArquivo) - 1;

  // pega a extensao do arquivo

  $extensao = $divideArquivo[$qtdElementos];
  return $extensao;
 }

 public

 function getCssHtml()
 {

  // pega o endere?o do diret?rio que cont?m os arquivos CSS

  $diretorio = "skin/css/";
  $arquivos = $this->getFiles($diretorio);

  // lista os arquivos se houverem

  if ($arquivos != "") {
   foreach($arquivos as $listar) {
    print '<link type="text/css" rel="stylesheet" href="' . $diretorio . $listar . '">';
   }
  }
 }

 public

 function setLink($link)
 {
  return $this->_baseUrl . $link;
 }

 public

 function setTitle($titulo)
 {
  $this->_title = $titulo;
 }

 public function setMeta($tipo, $conteudo)
 {
  if ($tipo == 'title'):
   $this->_metatitle = $conteudo;
  elseif ($tipo == 'description'):
   $this->_metadescription = $conteudo;
  elseif ($tipo == 'keywords'):
   $this->_metakeywords = $conteudo;
  else:
   $this->_metatitle = '';
   $this->_metadescription = '';
   $this->_metakeywords = '';
  endif;
 }

 public function modulos()
 {
  $modulos = new AtendimentoModel();
  $this->_modulos = $modulos->listaModulos();
  return $this->_modulos;
 }

 public function run()
 {
  $controller_path = CONTROLLERS . ucfirst($this->_controller) . 'Controller.php';
  if (!file_exists($controller_path)) die(Header("Location: " . $this->setLink('erros/')));
  require_once ($controller_path);

  $app = new $this->_controller();
  if (!method_exists($app, $this->_action)) die(Header("Location: " . $this->setLink('erros/')));
  $action = $this->_action;
  $app->$action();
 }

 public function config($page, $name)
 {
  $config = new Model();
  $valor = $config->doConfig($page, $name);
  return $valor;
 }

 public function getContato($info)
 {
  return $this->config('contato', $info);
 }

 public

 function getGoogle($info)
 {
  return $this->config('google', $info);
 }

 public function getTextos($info)
 {
  return $this->config('inicial', $info);
 }

 public function mostraData($data)
 {
  if ($data != '') {
   return (substr($data, 8, 2) . '/' . substr($data, 5, 2) . '/' . substr($data, 0, 4));
  }
  else {
   return '';
  }
 }

 public function retiraTagHTML($textoComTag)
 {
  echo strip_tags($textoComTag, '<(.*?)>');
 }

 public function diaSemana($dia)
 {
  switch ($dia) {
  case 1:
   $diaSemana = "Segunda-feira";
   break;

  case 2:
   $diaSemana = "Ter?a-feira";
   break;

  case 3:
   $diaSemana = "Quarta-feira";
   break;

  case 4:
   $diaSemana = "Quinta-feira";
   break;

  case 5:
   $diaSemana = "Sexta-feira";
   break;

  case 6:
   $diaSemana = "Sábado";
   break;

  case 7:
   $diaSemana = "Domingo";
   break;
  }

  return $diaSemana;
 }

 public function connectYoutubeApi($videoId)
 {

  // Definimos a url da API do Youtube

  define('YT_API_URL', 'http://gdata.youtube.com/feeds/api/videos?q=');

  // Using cURL php extension to make the request to youtube API

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, YT_API_URL . $videoId);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

  // $feed holds a rss feed xml returned by youtube API

  $feed = curl_exec($ch);
  curl_close($ch);

  // Using SimpleXML to parse youtube's feed

  $xml = simplexml_load_string($feed);
  $entry = $xml->entry[0];
  $media = $entry->children('media', true);
  $group = $media[0];
  return $group;
 }

 public function getYoutubeInfo($videoId)
 {
  $group = $this->connectYoutubeApi($videoId);
  $title = $group->title; //$title: The video title
  $desc = $group->description; //$desc: The video description
  $vid_keywords = $group->keywords; //$vid_keywords: The video keywords
  $thumb = $group->thumbnail[0]; //There are 4 thumbnails, The first is the largest.
  list($thumb_url, $thumb_width, $thumb_height, $thumb_time) = $thumb->attributes();
  $content_attributes = $group->content->attributes();

  // $vid_duration: the duration of the video in seconds. Ex.: 192.

  $vid_duration = $content_attributes['duration'];

  // $duration_formatted: the duration of the video formatted in "mm:ss". Ex.:01:54

  $duration_formatted = str_pad(floor($vid_duration / 60) , 2, '0', STR_PAD_LEFT) . ':' . str_pad($vid_duration % 60, 2, '0', STR_PAD_LEFT);
  return $duration_formatted;
 }

 /**
  * Remove espacos de uma string
  * @param string $texto Texto a ser filtrado
  * @return string Texto sem espacos
  */
 public function remover_espacos($texto)
 {
  return preg_replace('/\s/', '', $texto);
 }

 /**
  * Remove acentos de uma string
  * @param string $texto Texto a ser filtrado
  * @return string Texto sem acentos
  */
 public

 function remover_acentos($texto, $charset = 'UTF-8')
 {
  return iconv($charset, 'ASCII//TRANSLIT', $texto);
 }
}